#include <windows.h>
#include <stdio.h>

typedef void (WINAPI *INIT_GEN_RND)(unsigned long);
typedef unsigned long (WINAPI *GEN_RND32)(void);
typedef double (WINAPI *GEN_REAL2)(void);

int main(int argc, char **argv)
{
    HINSTANCE   hInstDLL;
    INIT_GEN_RND  InitGenRnd;
    GEN_RND32 GenRnd32;
    GEN_REAL2 GenReal2;
    int i;
    char* DLLNAME;
    static const int CNT = 100000000;

    LARGE_INTEGER sFreq, sCnt;
    LONGLONG t;

    if ( argc == 1 ) {
        return EXIT_SUCCESS;
    }

    DLLNAME = argv[1];
    if((hInstDLL=LoadLibrary(DLLNAME))==NULL)
      abort();

    // 
    memset(&sFreq, 0, sizeof(sFreq));
    memset(&sCnt, 0, sizeof(sCnt));
    QueryPerformanceFrequency( &sFreq );

    InitGenRnd=(INIT_GEN_RND)GetProcAddress(hInstDLL,"init_genrand");
    GenRnd32=(GEN_RND32)GetProcAddress(hInstDLL,"genrand_int32");

    QueryPerformanceCounter( &sCnt );
    t = sCnt.QuadPart;
    InitGenRnd(1234);
    for (i = 0; i < CNT; i++) {
        GenRnd32();
    }
    QueryPerformanceCounter( &sCnt );
    t = sCnt.QuadPart -  t;
    printf("int32:%1.15f sec\n", (double)t / sFreq.QuadPart);

    GenReal2=(GEN_REAL2)GetProcAddress(hInstDLL,"genrand_real2");
    QueryPerformanceCounter( &sCnt );
    t = sCnt.QuadPart;
    InitGenRnd(1234);
    for (i = 0; i < CNT; i++) {
        GenReal2();
    }

    QueryPerformanceCounter( &sCnt );
    t = sCnt.QuadPart -  t;
    printf("real2:%1.15f sec\n", (double)t / sFreq.QuadPart);

    if(!FreeLibrary(hInstDLL))
      abort();

    return  EXIT_SUCCESS;
}

